## mingw-w64-ruc-vm-1.2-1.src.tar.zst

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13.5)

project(ruc-vm)


# Put all libraries to one folder
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR})

# Set RPATH for searching dynamic libraries in the same folder
set(CMAKE_INSTALL_RPATH $ORIGIN @loader_path)
set(CMAKE_SKIP_BUILD_RPATH TRUE)
set(CMAKE_BUILD_WITH_INSTALL_RPATH TRUE)
set(CMAKE_INSTALL_RPATH_USE_LINK_PATH TRUE)


if(MSVC)
	add_compile_definitions(_CRT_SECURE_NO_WARNINGS)
else()
	add_compile_options(-Wno-unused-result)
endif()

# Disable asserts for Release build
add_compile_definitions("$<$<NOT:$<CONFIG:Debug>>:NDEBUG>")


# Add libraries
add_subdirectory(libs)

# Add frontend
add_subdirectory(src)


function(get_all_targets _targets _dir)
	get_property(_subdirs DIRECTORY ${_dir} PROPERTY SUBDIRECTORIES)

	foreach(_subdir IN LISTS _subdirs)
		get_all_targets(${_targets} ${_subdir})
	endforeach()

	get_property(_sub_targets DIRECTORY ${_dir} PROPERTY BUILDSYSTEM_TARGETS)
	set(${_targets} ${${_targets}} ${_sub_targets} PARENT_SCOPE)
endfunction()


# Set install parameters
get_all_targets(targets .)
install(TARGETS ${targets}
		RUNTIME DESTINATION ${PROJECT_NAME}
		LIBRARY DESTINATION ${PROJECT_NAME})


# Import testing exit code
if(DEFINED TESTING_EXIT_CODE)
	add_compile_definitions(TESTING_EXIT_CODE=${TESTING_EXIT_CODE})
endif()

=== libs/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13.5)


# Add interpreter library
add_subdirectory(interpreter)

# Add windows pthread
if(MSVC)
	add_subdirectory(pthread)
endif()

=== src/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13.5)

project(ruc-vm)


file(GLOB_RECURSE SRC CONFIGURE_DEPENDS "*.c")
file(GLOB_RECURSE HDR CONFIGURE_DEPENDS "*.h")

source_group("\\" FILES ${SRC} ${HDR})
add_executable(${PROJECT_NAME} ${SRC} ${HDR})
target_include_directories(${PROJECT_NAME} PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})


target_link_libraries(${PROJECT_NAME} interpreter)

=== libs/interpreter/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13.5)

project(interpreter)


file(GLOB_RECURSE SRC CONFIGURE_DEPENDS "*.c")
file(GLOB_RECURSE HDR CONFIGURE_DEPENDS "*.h")

source_group("\\" FILES ${SRC} ${HDR})
add_library(${PROJECT_NAME} SHARED ${SRC} ${HDR})
target_include_directories(${PROJECT_NAME} PUBLIC ${CMAKE_CURRENT_SOURCE_DIR})


if(MSVC)
	target_link_libraries(${PROJECT_NAME} pthread)
	target_compile_definitions(${PROJECT_NAME} PRIVATE HAVE_STRUCT_TIMESPEC)
else()
	find_package(Threads REQUIRED)
	target_link_libraries(${PROJECT_NAME} m ${CMAKE_THREAD_LIBS_INIT})
endif()

=== libs/pthread/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.13.5)

project(pthread)


add_library(${PROJECT_NAME} SHARED IMPORTED GLOBAL)


if(CMAKE_CL_64)
	set_target_properties(${PROJECT_NAME} PROPERTIES
		IMPORTED_LOCATION ${CMAKE_CURRENT_SOURCE_DIR}/x64/pthreadVC2.dll
		IMPORTED_IMPLIB ${CMAKE_CURRENT_SOURCE_DIR}/x64/pthreadVC2.lib
		INTERFACE_INCLUDE_DIRECTORIES ${CMAKE_CURRENT_SOURCE_DIR})

	install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/x64/pthreadVC2.dll
		DESTINATION ${CMAKE_PROJECT_NAME})

	file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/x64/pthreadVC2.dll DESTINATION ${CMAKE_BINARY_DIR}/Debug)
	file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/x64/pthreadVC2.dll DESTINATION ${CMAKE_BINARY_DIR}/Release)
else()
	set_target_properties(${PROJECT_NAME} PROPERTIES
		IMPORTED_LOCATION ${CMAKE_CURRENT_SOURCE_DIR}/x86/pthreadVC2.dll
		IMPORTED_IMPLIB ${CMAKE_CURRENT_SOURCE_DIR}/x86/pthreadVC2.lib
		INTERFACE_INCLUDE_DIRECTORIES ${CMAKE_CURRENT_SOURCE_DIR})

	install(FILES ${CMAKE_CURRENT_SOURCE_DIR}/x86/pthreadVC2.dll
		DESTINATION ${CMAKE_PROJECT_NAME})

	file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/x86/pthreadVC2.dll DESTINATION ${CMAKE_BINARY_DIR}/Debug)
	file(COPY ${CMAKE_CURRENT_SOURCE_DIR}/x86/pthreadVC2.dll DESTINATION ${CMAKE_BINARY_DIR}/Release)
endif()

=== PKGBUILD ===
# Maintainer: Konstantin Podsvirov <konstantin@podsvirov.pro>

_realName=RuC-VM
_realname=${_realName,,}
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=1.2
pkgrel=1
pkgdesc="Virtual machine for Russian version of C (mingw-w64)"
arch=('any')
mingw_arch=('mingw32' 'mingw64' 'ucrt64' 'clang64' 'clang32')
url='https://github.com/andrey-terekhov/RuC-VM'
license=('Apache-2.0')
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs")
makedepends=("${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-cc")
source=("${_realName}-${pkgver}.tar.gz::${url}/archive/v${pkgver}.tar.gz"
        '0001-ruc-vm-1.2-gnu-install-dirs.patch'
	'0002-ruc-vm-1.2-libruc-vm-prefix.patch')
sha256sums=('9aa43dd12092b562e2165a373141871b6b48806a075a92a1b7cb0865c491a9e1'
	    'c91727acc4bf2b30ce5911150da35eda832b1bab33e1cd8a2b8bb292707e9f0d'
            'e2a362b8a83071a87e67b20de2484729b720314832228885a50576ac09d65f03')

prepare() {
  cd "${srcdir}"/${_realName}-${pkgver}

  patch -Np1 -i "${srcdir}"/0001-ruc-vm-1.2-gnu-install-dirs.patch
#  patch -Np1 -i "${srcdir}"/0002-ruc-2.4.3-win32.patch
  patch -Np1 -i "${srcdir}"/0002-ruc-vm-1.2-libruc-vm-prefix.patch
}

build() {
  cd "${srcdir}/${_realName}-${pkgver}"
  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  declare -a extra_config
  if check_option "debug" "n"; then
    extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    "${MINGW_PREFIX}"/bin/cmake.exe \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      "${extra_config[@]}" \
      -DBUILD_{SHARED,STATIC}_LIBS=ON \
      ../${_realName}-${pkgver}

  "${MINGW_PREFIX}"/bin/cmake.exe --build .
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"

  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake.exe --install .

  install -Dm644 "${srcdir}/${_realname}-${pkgver}/LICENSE" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"
}
